#ifdef __APPLE__
#include "GLUT/glut.h"
#include <OPENGL/gl.h>
#endif
#ifdef __unix__
#include <GL/glut.h>
#endif
#ifndef __BOUND_H__
#define __BOUND_H__

#include <stdlib.h>
#include <stdio.h>
#include<iostream>
#include <math.h>
#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp" //perspective, trans etc
#include "glm/gtc/type_ptr.hpp" //value_ptr

/*The class for a normal bouncing ball*/
class Ball {
public:
   Ball();
	Ball(float radius, float bounciness, glm::vec3 location, glm::vec3 initVel);
	bool Accelerate(glm::vec3 change);
	glm::vec3 CheckMove();
	glm::vec3 MoveTo(glm::vec3 toMove);
	glm::vec3 Bounce(glm::vec3 wall);
	bool checkCollisionBall(glm::vec3 ball, float ballRad);


	glm::vec3 loc, velocity;
	float rad;
	float bounce;
};

/*The class for a bounding box that does not rotate*/
class StaticBB {
public:
	StaticBB();
	StaticBB(glm::vec3 coord, float length, float height, float width);
	bool checkCollisionBall(glm::vec3 ball, float ballRad);
	glm::vec3 checkCollisionBB(glm::vec3 preMove, StaticBB otherBox);
	glm::vec3 WhichWall(glm::vec3 ball, float ballRad);
	glm::vec3 updateLoc(glm::vec3 update);
	
	glm::vec3 loc;
	float len, ht, wid;
	float hLen, hWid, hHt;
	float radius;
};

/*The class for a bounding box that does rotate*/
class SpecialBB {
public:
   SpecialBB();
   SpecialBB(glm::mat4 initMatrix, float rad);
   bool checkCollisionBall(glm::vec3 ball, float ballRad);
   glm::vec3 WhichWall(glm::vec3 ball, float ballRad);
	void ChangeMatrix(glm::mat4 newMat);
	void ScaleRad(float scale);

	glm::vec4 groupAPt, groupBPt, loc;
	glm::vec4 groupAX, groupAY, groupAZ, groupBX, groupBY, groupBZ;
	glm::mat4 matrix;
	float radius;
};

#endif
