#ifdef __APPLE__
#include "GLUT/glut.h"
#include <OPENGL/gl.h>
#endif
#ifdef __unix__
#include <GL/glut.h>
#endif

#include "CMeshLoaderSimple.h"
#include <stdlib.h>
#include <stdio.h>
#include "GLSL_helper.h"
#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp" //perspective, trans etc
#include "glm/gtc/type_ptr.hpp" //value_ptr

#include "InputFunctions.h"

using namespace std;

int i;

//keyboard callback for when keys go up
void letgo(unsigned char key, int x, int y ) {
	switch( key ) {
		/*jump*/
		case 32:
	 		moveFlags[4] = false;
      	break; 
      /*strafe right*/
		case 'd':
			moveFlags[3] = false;
      	break;
      /*strafe left*/
		case 'a':
	 		moveFlags[1] = false;
			break;
		/*go forward*/
		case 'w':
		 	moveFlags[0] = false;
		   break;
   	/*go backwards*/
   	case 's':
    		moveFlags[2] = false;
   		break;
	}
}

//the keyboard callback
void keyboard(unsigned char key, int x, int y ){
	int tempX = eye.x, tempZ = eye.z, i;
	bool safeStart = true;
	
	switch( key ) {
		/*jump*/
		case 32:
	 		moveFlags[4] = true;
      	break;  
  		/*strafe right*/
		case 'd':
    		moveFlags[3] = true;
      	break;
      /*strafe left*/
		case 'a':
 			moveFlags[1] = true;
			break;
		/*go forward*/
		case 'w':
    		moveFlags[0] = true;
      	break;
      /*go backwards*/
		case 's':
			moveFlags[2] = true;
			break;
      
      /*Fire Balls*/
		case 'b':
			if (ballCount < 8) {
		   	for (i = 0; safeStart && i < wallCount; ++i) {
		   		if (walls[i].checkCollisionBall(eye + gaze, .2f))
		   			safeStart = false;
		   	}
		   	
		   	for (i = 0; safeStart && i < specWallCount; ++i) {
		   		if (SpecialWall[i].checkCollisionBall(eye + gaze, .2f))
		   			safeStart = false;
		   	}
		   	
		      if (safeStart) {
		         bouncies[ballCount] = Ball(.2f, 1, eye + gaze, -vecW*.5f);
		         ballCols[ballCount++] = 0;
		      }
			}
		   
		   break;
      
      /*Reload balls*/
		case 'r':
			ballCount = 0;     
			break;
	/*quit*/
    case 'q': case 'Q' :
      exit( EXIT_SUCCESS );
      break;
  }
  glutPostRedisplay();
}

void Mouse(int button, int state, int x, int y) {
	bool safeStart = true;
	
	/*look around with left click*/
	if (button == GLUT_LEFT_BUTTON) {
		if (state == GLUT_DOWN) {
			startX = x;
			startY = y;
		}
	}
  
  /*shoot balls with right click*/
	else if (button == GLUT_RIGHT_BUTTON) {
		if (state == GLUT_DOWN) {
			if (ballCount < 8) {
		   	for (i = 0; safeStart && i < wallCount; ++i) {
		   		if (walls[i].checkCollisionBall(eye + gaze, .2f))
		   			safeStart = false;
		   	}
		   	
		   	for (i = 0; safeStart && i < specWallCount; ++i) {
		   		if (SpecialWall[i].checkCollisionBall(eye + gaze, .2f))
		   			safeStart = false;
		   	}
		   	
		      if (safeStart) {
		         bouncies[ballCount] = Ball(.2f, 1, eye + gaze, -vecW*.5f);
		         ballCols[ballCount] = 0;
		         ++ballCount;
		      }
			}
		}
	}
  
	glutPostRedisplay();
	  
}

//x and y are the mouse location
/*allows the person to look around without letting go of left mouse*/
void Motion(int x, int y) {
	float dx, dy;
	
	dx = x - startX;
	dy = y - startY;
	
	startX = x;
	startY = y;
	
	pitch += (dy*3.14)/g_height; 
	yaw += (dx*3.14)/g_width;
	
	if (pitch > 1)
		pitch = 1;
	else if (pitch < -1 )
		pitch = -1;
	
	gaze.x = cos(pitch)*cos(yaw);
	gaze.y = sin(pitch); 
	gaze.z = cos(pitch)*cos(3.14/2 - yaw);
	
	vecW = glm::normalize(-gaze);
	vecU = glm::normalize(glm::cross(glm::vec3(0, 1, 0), vecW));
	vecV = glm::cross(vecW, vecU);
	
	
	glutPostRedisplay();
}
