struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

const int lightCt = 1;

varying vec4 tnormal;
varying vec4 light[lightCt];
varying vec4 v;
varying vec4 Refl[lightCt];
varying float dist[lightCt];

uniform int lightCount;

uniform mat4 uViewMatrix;
uniform vec3 uLightColArray[lightCt];
uniform Material uMat;

void main() {
	float dotNormLigh, dotVRefl;
	vec3 color = vec3(0, 0, 0);
	vec3 ambient = vec3(0, 0, 0);
	int i;

	for (i = 0; i < lightCt; ++i) {
		dotNormLigh = clamp(dot(normalize(tnormal), normalize(light[i])), 0.0, 1.0);
		dotVRefl = pow(clamp(dot(normalize(v), Refl[i]) , 0.0, 1.0), uMat.shine);	
	
		color += dist[i] * (uLightColArray[i] * uMat.dColor * dotNormLigh + uLightColArray[i]*uMat.sColor*dotVRefl); 
	}
	
	for (i = 0; i < lightCt; ++i){
		ambient += uLightColArray[i];
	}
	ambient = normalize(ambient);
	
	color += uMat.aColor*ambient;

	gl_FragColor = vec4(color, 1.0);
}
